/*
 * @OSF_FREE_FREE_COPYRIGHT@
 *
 */
/*
 * HISTORY
 * $Log: console.c,v $
 * Revision 1.1.2.2  1997/01/21  19:07:11  barbou
 * 	Added code to "probe" the video console.
 * 	[1997/01/21  18:23:08  barbou]
 *
 * Revision 1.1.2.1  1996/09/18  14:19:14  barbou
 * 	Created.
 * 	[1996/09/13  16:59:59  barbou]
 * 
 * $EndLog$
 */

#include <linux/autoconf.h>

#include <mach/mach_interface.h>

#include <osfmach3/mach_init.h>
#include <osfmach3/device_utils.h>
#include <osfmach3/console.h>
#include <osfmach3/parent_server.h>
#include <osfmach3/mach3_debug.h>

#include <linux/kernel.h>

#ifdef	CONFIG_PMAC_CONSOLE
extern void pmac_find_display(void);
#endif	/* CONFIG_PMAC_CONSOLE */

boolean_t
osfmach3_con_probe(void)
{
	kern_return_t	kr;

	if (parent_server || osfmach3_use_mach_console) {
		/* no virtual consoles */
		return FALSE;
	}

#ifdef	CONFIG_PMAC_CONSOLE
	/*
	 * Try the video console device.
	 */
	kr = device_open(device_server_port,
			 MACH_PORT_NULL,
			 D_READ | D_WRITE,
			 server_security_token,
			 "vc0",
			 &osfmach3_video_port);
	if (kr != D_SUCCESS) {
		MACH3_DEBUG(2, kr,
			    ("osfmach3_con_probe: device_open(\"vc0\")"));
		printk("osfmach3_con_probe: can't map display. "
		       "Using dumb console.\n");
		return FALSE;
	}

	pmac_find_display();
	return TRUE;
#else	/* CONFIG_PMAC_CONSOLE */
	return FALSE;
#endif	/* CONFIG_PMAC_CONSOLE */
}
