#ifndef __PPC_ELF_H
#define __PPC_ELF_H

/*
 * ELF register definitions..
 */

#define ELF_NGREG	40
#define ELF_NFPREG	33

typedef unsigned long elf_greg_t;
typedef elf_greg_t elf_gregset_t[ELF_NGREG];

typedef double elf_fpreg_t;
typedef elf_fpreg_t elf_fpregset_t[ELF_NFPREG];

#define elf_check_arch(x) ((x) == EM_PPC)

/*
 * These are used to set parameters in the core dumps.
 * FIXME(eric) I don't know what the correct endianness to use is.
 */
#define ELF_CLASS	ELFCLASS32
#define ELF_DATA	ELFDATA2MSB;
#define ELF_ARCH	EM_PPC

#define USE_ELF_CORE_DUMP
#define ELF_EXEC_PAGESIZE	4096

/* Dump registers in the same order as specified in PT_ macros */
/* floating point isn't dumped here... */

#define ELF_CORE_COPY_REGS(pr_reg, regs)				      \
	memset((char*)pr_reg, 0, sizeof(*pr_reg));			      \
	memcpy((char*)&pr_reg[PT_R0], (char*)&regs->gpr[0],32*sizeof(long)); \
	pr_reg[PT_NIP] = regs->nip;					      \
	pr_reg[PT_MSR] = regs->msr;					      \
	pr_reg[PT_CCR] = regs->ccr;					      \
	pr_reg[PT_XER] = regs->xer;					      \
	pr_reg[PT_LNK] = regs->link;					      \
	pr_reg[PT_CTR] = regs->ctr;					      \
	pr_reg[PT_ORIG_R3] = regs->orig_gpr3;
#endif
