/*
 * Copyright 1996 1995 by Open Software Foundation, Inc. 1997 1996 1995 1994 1993 1992 1991  
 *              All Rights Reserved 
 *  
 * Permission to use, copy, modify, and distribute this software and 
 * its documentation for any purpose and without fee is hereby granted, 
 * provided that the above copyright notice appears in all copies and 
 * that both the copyright notice and this permission notice appear in 
 * supporting documentation. 
 *  
 * OSF DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE 
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE. 
 *  
 * IN NO EVENT SHALL OSF BE LIABLE FOR ANY SPECIAL, INDIRECT, OR 
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM 
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT, 
 * NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION 
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 * 
 */
/*
 * MkLinux
 */

#include <kern/misc_protos.h>
#include <ppc/POWERMAC/powermac.h>

static void eieio(void);
static void eieio(void)
{
    __asm__ volatile("eieio" : :);
}

static void st_rev(volatile unsigned *addr, unsigned val);
static void st_rev(volatile unsigned *addr, unsigned val)
{
    __asm__ volatile("stwbrx %0,0,%1" : : "r" (val), "r" (addr) : "memory");
}

void awacs_initialize(void);
void awacs_initialize(void)
{
	unsigned *awacs;
	int hflag = 0, l, r, i;

	switch (powermac_info.class) {
	case	POWERMAC_CLASS_PDM:
		awacs = (unsigned *) POWERMAC_IO(PDM_AWACS_BASE_PHYS);
		break;
	case	POWERMAC_CLASS_PCI:
		awacs = (unsigned *) POWERMAC_IO(PCI_AWACS_BASE_PHYS);
		break;
	default:
		return;
	}

	st_rev(&awacs[4], 0x200);	/* turn on CD output */
	delay(1);
	st_rev(&awacs[4], 0x14c0);	/* turn on speaker AND headphone */
	delay(1);
	st_rev(&awacs[4], 0x0204);	/* output 'A' at '4' */
	delay(1);
	st_rev(&awacs[4], 0x0204);	/* output 'B' at '4' - ignored? */
	delay(1);
	st_rev(&awacs[4], 0x0204);	/* output 'C' at '4' */
}

