Description: GNU Binary Utility Development Utilities
Name: binutils
Version: 2.7
Release: 1E
Copyright: GPL
Group: Development/Tools
Source: ftp://prep.ai.mit.edu/pub/gnu/binutils-2.7.tar.gz
Patch0: binutils-2.7-ppc_shared_libraries.patch

%prep
%setup
%ifarch ppc
%patch0 -p 1
%endif

%build
%ifarch ppc
./configure --prefix=/usr ppc-linux-elf
make CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" LDFLAGS=-s
make info
%else
./configure --prefix=/usr 
make CFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s
make info
%endif

%install
cd binutils
for n in ar ranlib size objcopy objdump ar strings ranlib c++filt objcopy strip.new nm.new; do
    cp $n /usr/bin
    chmod 755 /usr/bin/$n
    strip /usr/bin/$n
done
mv -f /usr/bin/strip.new /usr/bin/strip
mv -f /usr/bin/nm.new /usr/bin/nm
strip /usr/bin/strip
strip /usr/bin/nm

%ifarch i386
cp encaps /usr/bin
chmod 755 /usr/bin/encaps
strip /usr/bin/encaps
%endif

cd ../gas
cp as.new /usr/bin
mv -f /usr/bin/as.new /usr/bin/as
strip /usr/bin/as
ln -sf as /usr/bin/gas
cp gasp.new /usr/bin
mv -f /usr/bin/gasp.new /usr/bin/gasp
strip /usr/bin/gas

##cd ../gprof
##cp gprof /usr/bin/gprof
##strip /usr/bin/gprof

cd ../ld
cp ld.new /usr/bin
mv -f /usr/bin/ld.new /usr/bin/ld
rm -rf /usr/lib/ldscripts
mkdir /usr/lib/ldscripts
cp ldscripts/* /usr/lib/ldscripts

cd ..
cp ./binutils/ar.1 /usr/man/man1
cp ./binutils/nlmconv.1 /usr/man/man1
cp ./binutils/nm.1 /usr/man/man1
cp ./binutils/objcopy.1 /usr/man/man1
cp ./binutils/objdump.1 /usr/man/man1
cp ./binutils/ranlib.1 /usr/man/man1
cp ./binutils/size.1 /usr/man/man1
cp ./binutils/strings.1 /usr/man/man1
cp ./binutils/strip.1 /usr/man/man1
cp ./gas/doc/as.1 /usr/man/man1
##cp ./gprof/gprof.1 /usr/man/man1
cp ./ld/ld.1 /usr/man/man1

cp bfd/bfd.h /usr/include/bfd.h

cp ./bfd/doc/bfd.info /usr/info
cp ./binutils/binutils.info /usr/info
cp ./etc/configure.info /usr/info
cp ./etc/cfg-paper.info /usr/info
cp ./gas/doc/as.info /usr/info
cp ./gas/doc/gasp.info /usr/info
##cp ./gprof/gprof.info /usr/info
cp ./ld/ld.info /usr/info

cd /usr/info
##gzip -f bfd.info binutils.info cfg-paper.info as.info gasp.info gprof.info ld.info
gzip -f bfd.info binutils.info cfg-paper.info as.info gasp.info ld.info

%files
/usr/bin/as
/usr/bin/ar
/usr/bin/c++filt
/usr/bin/gasp
%ifarch i386
/usr/bin/encaps
%endif
/usr/bin/ld
/usr/bin/nm
/usr/bin/objcopy
/usr/bin/objdump
/usr/bin/ranlib
/usr/bin/size
/usr/bin/strings
/usr/bin/strip
/usr/man/man1/as.1
/usr/man/man1/ar.1
/usr/man/man1/nm.1
/usr/man/man1/objcopy.1
/usr/man/man1/objdump.1
/usr/man/man1/ranlib.1
/usr/man/man1/size.1
/usr/man/man1/strings.1
/usr/man/man1/strip.1
/usr/man/man1/ld.1
/usr/include/bfd.h
/usr/lib/ldscripts
/usr/info/bfd.info.gz
/usr/info/binutils.info.gz
/usr/info/cfg-paper.info.gz
/usr/info/as.info.gz
/usr/info/gasp.info.gz
/usr/info/ld.info.gz
%ifnarch ppc
##/usr/bin/gprof
##/usr/man/man1/gprof.1
##/usr/info/gprof.info.gz
%endif