Description: GNU C Compiler
Name: gcc
Version: 2.7.2
Release: 2J
Copyright: GPL
Group: Development/Languages
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-2.7.2.tar.gz
Patch0: sunsite.unc.edu:/pub/Linux/GCC/gcc-2.7.2-linux.diff.gz
Patch1: gcc-2.7.2-make.patch
Patch2: gcc-2.7.2-ppc.patch
Patch3: gcc-2.7.2-ppc_shared_libraries.patch
Patch4: gcc-2.7.2.objc.960906.diff
Patch5: gcc-2.7.2-ppc_varargs.patch

%package c++
Description: C++ support for gcc
Summary: C++ support for gcc
Group: Development/Languages

# Wait until this works...
#%ifnarch ppc
%package objc
Description: Objective C support for gcc
Summary: Objective C support for gcc
Group: Development/Languages
#%endif

%prep
%setup
%patch0 -p2
%patch1 -p1 -b .rh

%ifarch ppc
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%endif

%build

%ifarch i386
./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ i486-linux
%endif
%ifarch axp
./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ alpha-linux
%endif
%ifarch ppc
CFLAGS="-O2" ./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ --with-gnu-as --with-gnu-ld ppc-linux
%endif

# Someday, when I have hours to burn...
%ifnarch ppc
make LANGUAGES=c
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"
%else
make LANGUAGES="c c++ objective-c proto objc-runtime"
%endif

# Wait until this works...
%ifnarch ppc
# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"
%endif

%install
rm -f /lib/cpp
rm -f /usr/info/gcc.info* /usr/info/cpp.info*
%ifnarch ppc
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s" install
%else
make LANGUAGES="c c++ objective-c proto" install
ln -sf /usr/include/g++ /usr/lib/g++-include
%endif

# Wait until this works...
#%ifnarch ppc
# For Objective C only
make install-libobjc CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"
#%endif

gzip -n -9f /usr/info/gcc.info* /usr/info/cpp.info*

rm -f /usr/bin/cc
ln -sf gcc /usr/bin/cc
ln -sf cccp.1 /usr/man/man1/cpp.1

%ifarch i386
ln -sf ../usr/lib/gcc-lib/i486-linux/2.7.2/cpp /lib/cpp
%endif
%ifarch axp
ln -sf ../usr/lib/gcc-lib/alpha-linux/2.7.2/cpp /lib/cpp
%endif
%ifarch ppc
ln -sf ../usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cpp /lib/cpp
%endif

%files
%doc NEWS PROBLEMS

%dir /usr/lib/gcc-lib
%ifarch i386
%dir /usr/lib/gcc-lib/i486-linux/2.7.2
%dir /usr/lib/gcc-lib/i486-linux/2.7.2/include
%endif
%ifarch axp
%dir /usr/lib/gcc-lib/alpha-linux/2.7.2
%dir /usr/lib/gcc-lib/alpha-linux/2.7.2/include
%endif
%ifarch ppc
%dir /usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux
%dir /usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include
%endif

%ifarch i386
/usr/bin/i486-linux-gcc
%endif 
%ifarch axp
/usr/bin/alpha-linux-gcc
%endif
%ifarch ppc
/usr/bin/powerpc-unknown-linux-gcc
%endif

/usr/bin/gcc
/usr/bin/cc
/usr/bin/protoize
/usr/bin/unprotoize

/lib/cpp

/usr/man/man1/cpp.1
/usr/man/man1/cccp.1
/usr/man/man1/gcc.1

/usr/info/cpp.info*
/usr/info/gcc.info*

%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/SYSCALLS.c.X
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1
/usr/lib/gcc-lib/i486-linux/2.7.2/cpp
/usr/lib/gcc-lib/i486-linux/2.7.2/libgcc.a
/usr/lib/gcc-lib/i486-linux/2.7.2/specs

/usr/lib/gcc-lib/i486-linux/2.7.2/include/README
/usr/lib/gcc-lib/i486-linux/2.7.2/include/float.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/iso646.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/limits.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/proto.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/stdarg.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/stddef.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/syslimits.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-alpha.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-clipper.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-h8300.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-i860.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-i960.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-m88k.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-mips.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-pa.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-pyr.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-sparc.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-spur.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/varargs.h
%endif

%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/SYSCALLS.c.X
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1
/usr/lib/gcc-lib/alpha-linux/2.7.2/cpp
/usr/lib/gcc-lib/alpha-linux/2.7.2/libgcc.a
/usr/lib/gcc-lib/alpha-linux/2.7.2/specs

/usr/lib/gcc-lib/alpha-linux/2.7.2/include/README
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/float.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/iso646.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/limits.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/proto.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/stdarg.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/stddef.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/syslimits.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-alpha.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-clipper.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-h8300.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-i860.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-i960.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-m88k.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-mips.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-pa.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-pyr.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-sparc.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-spur.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/varargs.h
%endif

%ifarch ppc
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/syslimits.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/stdarg.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/stddef.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/varargs.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-alpha.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-h8300.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-i860.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-i960.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-mips.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-m88k.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-pa.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-pyr.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-sparc.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-clipper.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-spur.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/iso646.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-ppc.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/proto.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/ppc-asm.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/limits.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/README
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/float.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/errno.h
#/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/curses.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/unistd.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/fixed
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cc1
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/specs
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cpp
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libgcc.a
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/nof
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/pic
%endif

%files c++
/usr/man/man1/g++.1
/usr/bin/g++
/usr/bin/c++

%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1plus
%endif
%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1plus
%endif
%ifarch ppc
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cc1plus
/usr/lib/g++-include
%endif

# Wait until this works...
#%ifnarch ppc
%files objc
%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1obj
/usr/lib/gcc-lib/i486-linux/2.7.2/libobjc.a
/usr/lib/gcc-lib/i486-linux/2.7.2/include/objc
%endif
%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1obj
/usr/lib/gcc-lib/alpha-linux/2.7.2/libobjc.a
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/objc
%endif
%ifarch ppc
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cc1obj
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libobjc.a
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/objc
%endif
#%endif
