Description: Process monitoring utilities
Name: procps
Version: 1.01
Release: 5D
Copyright: GPL
Group: Utilities/System
Source: ftp://sunsite.unc.edu//pub/Linux/system/Status/ps/procps-1.01.tgz
Patch0: procps-1.01-config.patch
Patch1: procps-1.01-cmdline.patch
Patch2: ftp://ftp.azstarnet.com/pub/linux/axp/glibc/procps-1.01axp.patch.gz
Patch3: procps-1.01-axponly.patch
Patch4: procps-1.01-xcpustate.patch
Patch5: procps-1.01-scale.patch
Patch6: procps-1.01-ppc.patch
Patch7: procps-1.01-ppc.glibc.patch

%ifnarch ppc
%package X11
Group: X11/Utilities
Description: X-based process monitoring utilities
Summary: X-based process monitoring utilities
%endif

%prep
%setup
%patch0 -p1
%patch1 -p1
%patch4 -p1

%ifnarch axp
%patch5 -p1
%endif

%ifarch axp
%patch2 -p1
%patch3 -p1
%endif

%ifarch ppc
%patch6 -p1
%patch7 -p1
%endif

%build
# Cannot understand, why make refuses to get INSTALLMAN from cmdline...
%ifarch sparc ppc
PATH=/usr/X11R6/bin:$PATH
export PATH
cd xproc
xmkmf -a
cd ../xcpustate
xmkmf -a
cd ..
rm -f psmisc/pstree
mv Makefile Makefile.wrong
sed 's/^INSTALLMAN.*$/INSTALLMAN = install/' < Makefile.wrong > Makefile
%endif

(cd xcpustate; make depend)
(cd xproc; make depend)

make CC="gcc -I/usr/X11/include -I/usr/include/ncurses -I`pwd` -I. $RPM_OPT_FLAGS" LDFLAGS=-s

%install
make install
mv /sbin/psupdate /usr/sbin

%ifnarch ppc
# xcpustate doesn't need to be setuid
chmod 555 /usr/X11R6/bin/xcpustate
%endif

# All binaries are stripped by LD and by install; it is not necessary
# to strip them a third time.  Several strips here removed.


# Argh: xload conflicts with package XFree86.  
# How good is rpm at finding conflicts hidden by symlinks?

%files
%doc NEWS BUGS TODO
/bin/ps
/usr/bin/free
/usr/bin/sessreg
/usr/bin/skill
/usr/bin/snice
/usr/bin/tload
/usr/bin/top
/usr/bin/uptime
/usr/bin/vmstat
/usr/bin/w
/usr/bin/watch
/usr/man/man1/free.1
/usr/man/man1/ps.1
/usr/man/man1/sessreg.1
/usr/man/man1/skill.1
/usr/man/man1/snice.1
/usr/man/man1/tload.1
/usr/man/man1/top.1
/usr/man/man1/uptime.1
/usr/man/man1/w.1
/usr/man/man1/watch.1
/usr/man/man8/psupdate.8
/usr/man/man8/vmstat.8
/usr/sbin/psupdate

%ifnarch ppc
%files X11
/usr/X11R6/bin/XConsole
/usr/X11R6/bin/xcpustate
/usr/X11R6/bin/xidle
/usr/X11R6/bin/xload
/usr/X11R6/bin/xmem
/usr/X11R6/lib/X11/app-defaults/XIdle
/usr/X11R6/lib/X11/app-defaults/XLoad
/usr/X11R6/lib/X11/app-defaults/XMem
%endif
